<?php

namespace App\Repository;

use App\Entity\Provider;
use App\Entity\Teacher;
use Doctrine\DBAL\Driver\AbstractMySQLDriver;
use Symfony\Component\Uid\Uuid;

/**
 * TeacherRepository.
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TeacherRepository extends \Doctrine\ORM\EntityRepository
{
    public function createWithImportData($importedData, Provider $provider, $idOnProvider)
    {
        if (!$importedData instanceof \App\ImporterFilter\ImportedEntity\Teacher) {
            return null;
        }

        $existent = $this->findOneBy(['fiscalCode' => $importedData->getFiscalCode()]);
        if ($existent instanceof Teacher) {
            throw new \Error("Teacher with fiscal code {$importedData->getFiscalCode()} already exists");
        }

        $teacher = new Teacher($importedData->getFiscalCode());
        $teacher->setFirstname($importedData->getFirstName());
        $teacher->setLastname($importedData->getLastName());

        if (null !== $importedData->getEmail()) {
            $teacher->setEmail($importedData->getEmail());
        }
        if (null !== $importedData->getUsername()) {
            $teacher->setUsername($importedData->getUsername());
        }
        if (null !== $importedData->getPassword() && null === $teacher->getStartingPassword()) {
            $teacher->setStartingPassword($importedData->getPassword());
        }

        $teacher->setProvider($provider);
        $teacher->setIdOnProvider($idOnProvider);
        $this->getEntityManager()->persist($teacher);
        $this->getEntityManager()->flush();

        return $teacher;
    }

    public function updateWithImportData(Teacher $teacher, $newData, Provider $provider)
    {
        if (!$newData instanceof \App\ImporterFilter\ImportedEntity\Teacher) {
            return $teacher;
        }

        $teacher->setFiscalCode($newData->getFiscalCode());
        $teacher->setFirstname($newData->getFirstName());
        $teacher->setLastname($newData->getLastName());

        if (null !== $newData->getEmail()) {
            $teacher->setEmail($newData->getEmail());
        }
        if (null !== $newData->getUsername()) {
            $teacher->setUsername($newData->getUsername());
        }
        if (null !== $newData->getPassword() && null === $teacher->getStartingPassword()) {
            $teacher->setStartingPassword($newData->getPassword());
        }

	    $teacher->setTrashedDate(null); //untrash the teacher

        $this->getEntityManager()->flush();

        return $teacher;
    }

    public function getUsernamesNotInLdapUser()
    {
        $em = $this->getEntityManager();

        $query = $em->createQuery('SELECT t.username FROM App\Entity\Teacher t LEFT JOIN App\Entity\LdapUser l WITH t.username = l.username WHERE l.username IS NULL AND NOT t.username IS NULL');
        $query->execute();
        $results = $query->getResult();

        $usernames = [];
        foreach ($results as $result) {
            $usernames[] = strtolower($result['username']);
        }

        return $usernames;
    }

	public function getTeachersWithoutManagedDeviceQuery($filters=[], $providers=null, $noTrashed=true) {
		$queryBuilder = $this->createQueryBuilder("s")
		                     ->leftJoin("s.mdmDevices", 'd')
		                     ->addGroupBy("s.id")
		                     ->having("COUNT(d.id) = 0")
		                     ->addOrderBy('s.provider', 'ASC')
		                     ->addOrderBy('s.lastname', 'ASC');

		if(isset($filters['providerId']) && $filters['providerId'] != "") {
			if($this->getEntityManager()->getConnection()->getDriver() instanceof AbstractMySQLDriver) {
				$queryBuilder->andWhere( "s.provider = :pid" )->setParameter( "pid", (new Uuid($filters['providerId']))->toBinary() );
			} else {
				$queryBuilder->andWhere( "s.provider = :pid" )->setParameter( "pid", $filters['providerId'] );
			}
		}

		if(!empty($providers)) {
			$queryBuilder->andWhere($queryBuilder->expr()->in("s.provider", ':pids'));

			if($this->getEntityManager()->getConnection()->getDriver() instanceof AbstractMySQLDriver) {
				$queryBuilder->setParameter( 'pids', array_map( fn ( $provider ) => $provider->getId()->toBinary(), $providers ) );
			} else {
				$queryBuilder->setParameter( 'pids', array_map( fn ( $provider ) => $provider->getId(), $providers ) );
			}
		}

		if($noTrashed) {
			$queryBuilder->andWhere("s.trashedDate IS NULL");
		}

		return $queryBuilder->getQuery();
	}

	public function getTrashedQuery($providerId=null): \Doctrine\ORM\Query
    {
		$queryBuilder = $this->createQueryBuilder('s')->where('NOT s.trashedDate IS NULL');
		if($providerId !== null) {
			$queryBuilder->andWhere("s.provider = :pids");
			if($this->getEntityManager()->getConnection()->getDriver() instanceof AbstractMySQLDriver) {
				$queryBuilder->setParameter('pids', $providerId->toBinary());
			} else {
				$queryBuilder->setParameter('pids', $providerId);
			}
		}

		return $queryBuilder->getQuery();
	}

	public function getNotTrashedQuery($providerId=null): \Doctrine\ORM\Query
    {
		$queryBuilder = $this->createQueryBuilder('s')->where('s.trashedDate IS NULL');
	    if($providerId !== null) {
		    $queryBuilder->andWhere("s.provider = :pids");
		    if($this->getEntityManager()->getConnection()->getDriver() instanceof AbstractMySQLDriver) {
			    $queryBuilder->setParameter('pids', $providerId->toBinary());
		    } else {
			    $queryBuilder->setParameter('pids', $providerId);
		    }
	    }

		return $queryBuilder->getQuery();
	}

    public function getTrashed()
    {
        return $this->createQueryBuilder('t')
                    ->andWhere('NOT t.trashedDate IS NULL')
                    ->orderBy('t.lastname', 'ASC')
                    ->getQuery()
                    ->execute();
    }
}
